SystemOrganization addCategory: #'SeasideFAQ-Model'!
SystemOrganization addCategory: #'SeasideFAQ-Tests'!
SystemOrganization addCategory: #'SeasideFAQ-Presentation'!

!WAHtmlStreamDocument class methodsFor: '*SeasideFAQ' stamp: 'mb 1/11/2007 14:22'!
forHtml
	^self new forHtml! !

Object subclass: #WAFAQCategory
	instanceVariableNames: 'id index title questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

!WAFAQCategory class methodsFor: 'instance creation' stamp: 'pmm 3/30/2007 13:15'!
new
	"its 2007 FFS, is it really asked too much that objects receive #initialize upon creation per default is Smalltalk just a pile of leagy crap"
	^self basicNew initialize! !

!WAFAQCategory methodsFor: 'comparing' stamp: 'pmm 3/30/2007 13:01'!
= other
	^(other isKindOf: WAFAQCategory)
		and: [ self title = other title ]! !

!WAFAQCategory methodsFor: 'adding' stamp: 'pmm 3/30/2007 13:13'!
addQuestion: aFaq
	^self questions add: aFaq! !

!WAFAQCategory methodsFor: 'adding' stamp: 'pmm 3/30/2007 13:13'!
addQuestions: aFaq
	^self questions addAll: aFaq! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:22'!
detailId
	^'#detail-', self id displayString! !

!WAFAQCategory methodsFor: 'comparing' stamp: 'pmm 3/30/2007 13:01'!
hash
	^self title hash! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:01'!
id
	^id! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:01'!
id: anObject
	id := anObject! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:01'!
index
	^index! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:01'!
index: anObject
	index := anObject! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:17'!
indexOfQuestion: aFaq
	^self questions indexOf: aFaq! !

!WAFAQCategory methodsFor: 'initialize-release' stamp: 'pmm 3/31/2007 00:08'!
initialize
	super initialize.
	self questions: SortedCollection new! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:02'!
questions
	^questions! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:02'!
questions: anObject
	questions := anObject! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:02'!
title
	^title! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:02'!
title: anObject
	title := anObject! !

!WAFAQCategory methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:22'!
tocId
	^'#toc-', self id displayString! !

Object subclass: #WAFAQRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

WAFAQRepository class
	instanceVariableNames: 'default'!

WAFAQRepository class
	instanceVariableNames: 'default'!

!WAFAQRepository class methodsFor: 'instance creation' stamp: 'mb 8/18/2006 15:23'!
default
	default isNil ifTrue: [default := self new].
	^default.! !

!WAFAQRepository methodsFor: 'constants' stamp: 'mb 8/18/2006 16:00'!
categoryUnclassified
	^self repositoryData categoryUnclassified! !

!WAFAQRepository methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:17'!
contents
	| categories categoryRegistry |
	categoryRegistry := Dictionary new.
	self index do: [ :category | categoryRegistry at: category put: Set new].
	
	self repositoryData findAll do: [ :faq |
		| category |
		category := faq category ifNil: [ self categoryUnclassified ].
		(categoryRegistry at: category ifAbsentPut: [ Set new ]) add: faq ].
	
	categories := self index asOrderedCollection collect: [ :faqCategory |
		| faqs |
		faqs := categoryRegistry at: faqCategory.
		categoryRegistry removeKey: faqCategory.
		faqCategory addQuestions: faqs asSortedCollection.
		faqCategory ].
	
	categoryRegistry keysAndValuesDo: [ :faqCategory :faqs |
		faqCategory addQuestions: faqs asSortedCollection.
		categories add: faqCategory ].
	
	^categories! !

!WAFAQRepository methodsFor: 'constants' stamp: 'mb 8/18/2006 16:00'!
index
	^self repositoryData index! !

!WAFAQRepository methodsFor: 'accessing' stamp: 'mb 8/18/2006 15:32'!
repositoryData
	^WAFAQRepositoryData default! !

Object subclass: #WAFAQRepositoryData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 4/22/2007 22:41'!
categoryContribute
	^WAFAQCategory new
		title: 'How to contribute';
		id: 'how-to-contribute';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:02'!
categoryDeployment
	^WAFAQCategory new
		title: 'Deployment and maintenance';
		id: 'deployment-and-maintenance';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:03'!
categoryErrors
	^WAFAQCategory new
		title: 'Errors and messages';
		id: 'errors-and-messages';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:03'!
categoryGeneral
	^WAFAQCategory new
		title: 'General';
		id: 'general';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:03'!
categoryHowTo
	^WAFAQCategory new
		title: 'How to';
		id: 'how-to';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:19'!
categoryUnclassified
	^WAFAQCategory new
		title: 'As yet unclassified';
		id: 'unclassified';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:04'!
categoryWhat
	^WAFAQCategory new
		title: 'What/Why';
		id: 'what';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'pmm 3/30/2007 13:04'!
categoryWhatWrong
	^WAFAQCategory new
		title: 'What is wrong';
		id: 'what-is-wrong';
		yourself! !

!WAFAQRepositoryData class methodsFor: 'singleton' stamp: 'mb 8/18/2006 13:39'!
default
	^self! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'mb 8/18/2006 16:14'!
factory
	^WAFrequentlyAskedQuestion! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 4/6/2007 13:05'!
faq1
	^self
		question: 'What is Seaside?'
		category: self categoryGeneral 
		htmlResponse: [:html |
			html paragraph: 
'Seaside is an open source web application framework written in Smalltalk.' ]
! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 3/30/2007 21:25'!
faq10
	^self
		question: 'Nothing happens when I click this link?'
		category: self categoryWhatWrong
		title: 'Callback not evaluated with the Canvas api'
		htmlResponse: [:html |
			html paragraph:
'When the callback attached to an anchor is not evaluated, make sure you check that #with: or #text: is the last message sent to the anchor brush.'.
			html code: [html preformatted:			
'	html anchor
		callback: [ self close ];
		with: [
			html image
				fileName: ''closeButton.png'';
				mimeType: ''image/png''].
'].
			]! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 3/30/2007 21:26'!
faq11
	^self
		question: 'What is canvas API, what is the motivation?'
		category: self categoryWhat
		title: 'The canvas API by Avi Bryant'
		htmlResponse: [ :html |

html paragraph: [
	html text: 'See original post '.
	html anchor
		url: 'http://lists.squeakfoundation.org/pipermail/seaside/2005-June/005260.html';
		with: 'in the mailinglist'.
	html text: '.' ].

html paragraph: [
	html text: 
'The basic problem that Canvas is trying to solve is that of
combinatorial explosion in the protocol of WAHtmlRenderer.  Consider
something like a text input.  The original, basic method for rendering
a text input was #textInputWithValue:callback:'.

html preformattedCode: 
'	html textInputWithValue: person name callback: [:v | person name: v]' ].
	
html paragraph: [
html text: 'But there''s also a variation using the ...On:of: pattern:'.

html preformattedCode:
'	html textInputOn: #name of: person' ].

html paragraph: [
html text: 'And a variation with a liveUpdate callback:'.

html preformattedCode:
'	html
		textInputWithValue: person name
		callback: [:v | person name: v]
		liveCallback: [:r :v | ...]' ].

html paragraph:
'Now what if we want to use both of these variations at once?  Do we
also need #textInputOn:of:liveCallback:?  What about
#passwordInputOn:of:liveCallback:?   And so on.  It''s relatively easy
to add new convenience methods, but it''s a huge pain to combine them,
even when (as in this case) they''re totally orthogonal.'.

html paragraph: [
	html text: 
'The Canvas renderer is just a slight change to the API style that
makes this kind of combination much easier.  It divides what would
have been a single method on HtmlRenderer into three steps:  first,
you tell the canvas what kind of "brush" (tag, usually) you want to
use.  For example, the method #textInput will return a new instance of
WATextInputTag.  Then, you use protocol specific to that brush to
configure it: for example, you might send it some combination of
#value:, #callback:, #liveCallback:, #on:of:, etc.  You almost never
need to use temps when doing this, but can do it with cascades
instead:'.
	html preformattedCode:
'	html textInput
		value: person name;
		callback: [:v | person name: v]' ].

html paragraph: [
html text: 'or'.

html preformattedCode:
'	html textInput on: #name of: person' ].

html paragraph: [
html text: 'or'.

html preformattedCode:
'	html textInput
		on: #name of: person;
		liveCallback: [:r :n | ....]' ].

html paragraph: [
	html text:
'The third step is to render any contents or children (if any) of this
tag.  You do this by passing some renderable (often a block) to the
method #with:.  A text input wouldn''t have any, but consider something
like a table:'.

html preformattedCode:
'	html tableRow
		rowSpan: 3;
		with:
		     [html tableData with: [html bold with: person name].
		     (html tableData) colSpan: 2; with: [....]] ' ].

html paragraph:

'Note that instead of using #attributeAt:put: before the element, as in
HtmlRenderer, attributes are set as part of the configuration step -
and so classes like WATableRow can implement convenience methods for
common attributes like #rowSpan: as needed.'.


html paragraph: [
	
html text:
'If no configuration is needed, you can combine the first and third
steps by using a keyword message instead of a unary message to specify
the brush type, which is more compact:'.

html preformattedCode:
'	html tableRow
		rowSpan: 3;
		with:
		    [html tableData: [html bold: person name].
		    html tableData ....] ' ].

html paragraph:
'This style of API still allows streaming - the HTML for the open tag
is generated as soon as #with: is sent.  If #with: is never sent, it&quot;s
triggered automatically (with an empty block) whenever the next tag is
started.  That means #with: does have to be the last thing you send,
any configuration done afterwards will have no effect.'.

html paragraph: [
html text: 'Sometimes a temp is handy:'.
html preformattedCode:
'	myDiv := html div.
	self useSpecialId ifTrue: [myDiv id: "specialId"].
	myDiv with: [html text: ....]' ].
	
html paragraph:
'But bear in mind that these are basically temporary objects - it won''t
do you any good to stash them in an ivar and try to use them later,
for example.'.

html paragraph:
'The Canvas implementation in recent 2.6a versions is relatively
complete (we''re using it on one of the projects I''m working on), but
there are no doubt still lots of holes to patch up and conveniences to
add, so feel free to pitch in.'.

html paragraph: [
	html text: 'Avi Bryant'.
	html break.
	html text: 'Mon Jun 20 17:18:45 CEST 2005' ] ].! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 3/30/2007 21:25'!
faq12
	^self
		question: 'I have problems with the canvas api, where should I look?'
		category: self categoryWhatWrong
		title: 'Canvas troubles'
		response:

'Make sure you check that #with: or #text: is the last message sent to the anchor brush.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:34'!
faq13
	^self
		question: 'What is the most simple way to serve files from a Seaside application?'
		category: self categoryHowTo
		title: 'Serving files'
		htmlResponse: [:html |
			html paragraph:
'The most convenient way to serve files like pictures or stylesheets from a Seaside application is WAFileLibrary. See the class comment of WAFileLibrary for more information about how to use it.'.
			html paragraph:
'The following assumes that you have defined MyFileLibrary as explained in the class comment.'.
			html paragraph:
'First you will need to setup the root of your library. Typically this can be returned by a method.'.
			html code: [html preformatted:
'	library
		^MyFileLibrary'].
			html paragraph:
'To display an image'.
			html code: [html preformatted:
'		html image url:
			"myPicturePng is the method in which the picture is stored"
			(self library urlOf: #myPicturePng).
'].
			html paragraph:
'To display an image button (within a form)'.
			html code: [html preformatted:
'		html imageButton
			url: (self library urlOf: #myButton.gif);
			callback: [self commit].
'].
			html paragraph:
'To add a stylesheet and a javascript'.
			html code: [html preformatted:
'	updateRoot: anHtmlRoot
		super updateRoot: anHtmlRoot.
		anHtmlRoot stylesheet url: 
			(self library urlOf: #myStyle.css).
		anHtmlRoot javascript url: 
			(self library urlOf: #myJavascript.js).
'].
			html paragraph:
'Advanced users might want to use Apache 2.'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:28'!
faq14
	^self
		question: 'How do I access the initial request fields in my root component or task?'
		category: self categoryHowTo
		title: 'Accessing fields of initial request'
		response:

'To access the initial request fields in a root component or task override #initialRequest:. You will get a request object as argument that you can ask for #fields.'! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 3/30/2007 21:26'!
faq15
	^self
		question: 'I have problems with forms or input fields, where should I look?'
		category: self categoryWhatWrong
		title: 'Form or input field troubles'
		response:

'Make sure that you have one, and only one form around your input fields.'! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq16
	^self
		question: 'Are there any special hosting offers for seaside applications?'
		category: self categoryGeneral
		title: 'Seaside Hosting'
		htmlResponse: [:html |
			html text: 'There is '.
			html anchor
				url: 'http://www.seasidehosting.st';
				with: 'Seaside-Hosting'.
			html text: ' which is a free hosting service for non-commercial Seaside applications. '.
			html text: 'It is only for Squeak.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 3/30/2007 21:26'!
faq17
	^self
		question: 'What is the new header API, what is the motivation?'
		category: self categoryWhat
		title: 'The canvas header API'
		htmlResponse: [ :html |

html paragraph: [
	html text: 'See original post '.
	html anchor
		url: 'http://lists.squeakfoundation.org/pipermail/seaside/2006-October/009570.html';
		with: 'in the mailing list'.
	html text: ''].

html paragraph: 'Hi'.

html paragraph: 'Now that both Seaside 2.7a1 and 2.6b1 have the "new" header API i think its time
to write something short about it so people don''t have to ask.'.

html paragraph:
'The old header API was suffering from the same problems as the old
renderer API. Just to add an stylesheet with media and title you had
to copy and paste about 4 methods. Addional 4 for alternate
stylesheets. If you wanted a new conditional import you needed to copy
and paste a 3 LOC method.  And so on. So we followed the same path
like the Canvas API and made use of cascades.'.

html paragraph: [
	html text: 'The new API offers four base methods to create elements'.
	html unorderedList
		list: #(
			'#base, for base elements'
			'#if, for conditional imports'
			'#link, for link elements'
			'#meta, for meta elements'
			'#script, for script elements') ].

html paragraph: [
	html text: 'Most of the time will want to use one of these two convenience methods:'.
	html unorderedList
		list: #(
			'#javascript, for JavaScripts'
			'#stylesheet, for CSS stylesheets') ].
		
html paragraph:

'See the classes WABaseElement, WAConditionalComment, WALinkElement, WAMetaElement and
WAScriptElement for details'.

html paragraph: [
	html text: 'examples:'.
	
	html preformattedCode:
'aRoot stylesheet
    url: ''styles/blue.css'''.

	html preformattedCode:
'aRoot stylesheet
    document: ''a { color:red; }'''.

	html preformattedCode:
'aRoot javascript
    url: ''scripts/scriptaculous.css'.

	html preformattedCode:
'aRoot if lessThan; ie7; do: [
    aRoot javascripts
        url: ''iehacks.js'' ]' ].

html paragraph: [
	html text: 'stuff that was just awkward to do with the old api:'.

	html preformattedCode:
'aRoot link beAlternateStylesheet; beCss;
    addProjection; addPrint;
    title: ''Blue'';
    url: ''styles/blue.css''' ].

html paragraph:
'Contrary to the Canvas renderer API the new header API in the
background still used the old implementation. So you will have to
implement no methods like #rendererClass.'.

html paragraph:
'If you use the old API on Seaside 2.7a1 and have the development toolbar on you
will get a warning pointing to where you use the old API. These methods include
the code that you should replace yours with.'.

html paragraph: 'Philippe' ]! !

!WAFAQRepositoryData class methodsFor: 'faq errors' stamp: 'pmm 3/30/2007 21:29'!
faq18
	^self
		question: 'Error: Components not found while processing callbacks: ....'
		category: self categoryErrors
		title: 'Components not found'
		response:
		
'Make sure return any subcomponents of a component in the #children method. If the subcomponents change over the lifetime of the component, register it for backtracking.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:28'!
faq19
	^self
		question: 'How do I clean up external resources owned by Seaside sessions?'
		category: self categoryHowTo
		title: 'Cleaning up Seaside sessions'
		htmlResponse: [ :html |
			
html paragraph:
'When a Seaside session is not used during a certain duration, it expires. After a session has expired, it cannot be used any more.'.

html paragraph:
'By default, this duration is 10 minutes (600 seconds) but it can be set to any other desired value using the "config" application ("Session Expiry" field). It can also be set programmatically'.

html preformattedCode: 
'	app preferenceAt: #sessionExpirySeconds put: 1200'.

html paragraph:
'From time to time, Seaside processes expired sessions (see #unregisterExpiredHandlers). Expired sessions are removed from Seaside, making them candidates for future garbage collections, then they are sent #unregistered. The standard implementation of #unregistered in WASession is empty.'.

html paragraph:
'If it is necessary to release resources held by an expired Seaside session, this can be done by subclassing WASession and by reimplementing the #unregistered method.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq2
	^self
		question: 'Is Seaside ready for production?'
		category: self categoryGeneral 
		title: 'Is Seaside production ready'
		response: 'Seaside is used productively for many commercial and non-commercial applications.'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:28'!
faq20
	^self
		question: 'How do I subclass WASession?'
		category: self categoryHowTo
		title: 'Subclassing WASession'
		htmlResponse: [ :html |
			
html paragraph:
'It is sometimes necessary to subclass WASession. Typical situations for subclassing WASession.'.

html paragraph: [
	html unorderedList
		list: #(
	'Need to clean-up external resources when Seaside session expires (reimplement #unregistered)'
	'Need to attach some data to the Seaside session using additional instance variables'
	'Need to include additional behavior, statistics, monitoring (reimplement #responseForRequest:)') ].

html paragraph:
'Seaside applications are assigned their session class using the "config" application ("Session Class" field). It can also be set programmatically'.

html preformattedCode: 
'	app preferenceAt: #sessionClass put: MySession' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq21
	^self
		question: 'How do I subclass WAApplication?'
		category: self categoryHowTo
		title: 'Subclassing WAApplication'
		htmlResponse: [ :html |
			
html paragraph:
'It is sometimes necessary to subclass WAApplication, for instance when it is needed to display a session expiration page.'.

html paragraph:
'When you subclass WAApplication, make sure that the subclass reimplements #description on the class side, this will ensure that you can differentiate the WAApplication subclasses in the "config" application. Once the WAApplication is in place you can use the "config" application to create your Seaside application.'.

html paragraph:
'New Seaside applications can also be created programmatically by carefully reimplementing #applicationWithPath: on the class side of your root component.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 3/30/2007 21:26'!
faq22
	^self
		question: 'My Seaside session object does not receive #unregistered?'
		category: self categoryWhatWrong
		title: 'Cleaning up Seaside sessions'
		htmlResponse: [:html |
			html paragraph:
'When a Seaside session is not used during a certain duration, it expires. After a session has expired, it cannot be used any more.'.
			html paragraph:
'From time to time, Seaside processes expired sessions and sends them #unregistered. This is not immediate and it may take some time before Seaside enters this expiry process. With its default algorithm, Seaside expiry process occurs only when starting a new session, once every 10 sessions in average (see #registerRequestHandler: and #shouldCollectHandlers). If no new session are started, the #unregistered message is not sent. The more new sessions are created, the more the #unregistered message is sent.'.
			html paragraph:
'Beware, a common mistake is to name the method #unregister rather than #unregistered'.

			html heading level4; with: 'Avi Bryant 3 Oct 2004'.
			html paragraph: [
				html anchor url: 'http://lists.squeakfoundation.org/pipermail/seaside/2004-October/003704.html'; with: 'Original post'].
			html paragraph:
'One of the things I added in the recent 2.5b5 release was an ExpiryTest  application which let me do some ad-hoc testing of the expiration and unregistration mechanism. As far as I can tell, things are actually working, although it''s fairly erratic when exactly #unregistered will get sent - usually quite a while after the session actually expires, since the cleanup is only triggered by (on average) every 10th new session creation.'.
			html paragraph:
'If you want to play with this yourself, execute "WAExpiryTest install" and then go to /seaside/expiry. Hopefully the links/stats are fairly self explanatory.'.
			html paragraph:
'I think what I will probably do is start a background process that does the cleanup every few minutes, instead. The only small concern I have about this is that it''s one more thing to break - you might not notice that the cleanup process had died somehow, and end up with a lot of expired sessions sitting around in memory. The way it is now, it''s tied directly to the web server process, and if that goes down you''ll hear about it :).'.
			html paragraph:
'Avi'.
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq23
	^self
		question: 'How do I get the requester''s IP address?'
		category: self categoryHowTo
		title: 'Getting the requester''s IP address'
		htmlResponse: [ :html |

html paragraph:
'It is sometimes necessary to know the IP address of the requester. For instance you may want to produce a different behavior when the request comes from "localhost".'.

html paragraph:
'The IP address is normally available from the native request object. The native request object is obtained by sending #nativeRequest to the current Seaside request object, like this:'.

html preformattedCode:
'	renderContentOn: html
		nativeRequest := self session currentRequest nativeRequest.'.

html paragraph:		
'The native request object will be a Kom request, a Swazoo request or a WebToolkit request depending on the exact environment.'.

html paragraph:
'For instance, with Squeak'.

html preformattedCode:
'		ipAddress := nativeRequest remoteAddress.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq24
	^self
		question: 'How do  I display an expiration page?'
		category: self categoryHowTo
		title: 'Displaying an expiration page'
		htmlResponse: [ :html |

html paragraph:
'When the user wants to reuse an expired Seaside session, Seaside silently starts a new session. It is sometimes necessary to change this default behavior and notify the user that the session has expired.'.

html paragraph:
'First thing to do is to subclass WAApplication. Next thing is to reimplement either #handleExpiredRequest: or #expiryPathFor:'.

html paragraph:
'In #handleExpiredRequest: you are given a chance to build a redirect response to another Seaside application that will display the expiration component.'.

html paragraph:
'Below is a very simple example based on reimplementing #expiryPathFor:'.

html preformattedCode:
'	expiryPathFor: aRequest
		^ self basePath , ''?expired=true'''.

html paragraph:
'The expired=true field can be obtained by implementing #initialRequest: in the application root component, for instance'.

html preformattedCode:
'	initialRequest: aRequest
		(aRequest fields includesKey: ''expired'') ifPresent: [restartedAfterExpiration := true].'.

html paragraph:
'The rendering can then take expiration into consideration, for instance'.

html paragraph:
'	renderContentOn: html
		restartedAfterExpiration
			ifTrue: [ self renderExpiredOn: html ]
			ifFalse: [ self renderNormalOn: html ]' ] ! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 3/30/2007 21:26'!
faq25
	^self
		question: 'What is source code structure of Seaside in VisualWorks?'
		category: self categoryWhat
		title: 'Bundle structure of Seaside in VisualWorks public repository'
		htmlResponse:

'
<p>For many different reasons Seaside is broken into a complex and cumbersome bundle/package structure.</p>
<p>At a higher level, Seaside is broken into three bundles :
<ul>
	<li>Seaside-VW</li>
	<li>Seaside</li>
	<li>Seaside-WekToolKit</li>
</ul>
that must be loaded in the exact same order shown above.</p>

<p>The first bundle Seaside-VW contains pre-requisites and is actually preparing VisualWorks for Seaside. This bundle also has a complex structure. See below for further details.</p>
<p>The second bundle Seaside contains the original Seaside code unaltered from Squeak. The structure of this bundle is derived from the corresponding Seaside Monticello package. No further details are provided here.</p>
<p>The third bundle Seaside-WebToolKit contains the integration code for running Seaside inside the WebToolkit framework, along with some patches to both Seaside and WebToolkit. See below for more information.</p>
<p><strong>Note:</strong> There exists also a Seaside-Swazoo bundle that contains the integration code for running Seaside inside the Swazoo framework. This is described below in more details.</p>
<p><strong>One-click loading:</strong> Loading Seaside means loading the three bundles in the order above, making sure the bundle versions are compatible. However to provide one-click loading, there is another bundle named SeasideForWebToolkit that contains a script that loads the three bundles programmatically.</p>

<p>The contents of the Seaside-VW bundle are :
<ul>
	<li>Squeak-Chronos - This bundle adds Squeak compatibility to the base VisualWorks image and includes a full port of the Squeak Chronology classes providing classes like Duration, Year, Month, Week, etc. This bundle contains all the known Squeak compatibility extensions that could be found in the repository. It can be used for any project that needs Squeak compatibility.</li>
	<li>Seaside-Store-Patch - This package includes a patch to Store to allow loading of packages that include a $/ in their name. Note : Those names were given a few years ago, renaming those packages would be a risky task.</li>
	<li>Seaside - This package defines the Seaside namespace. The definition of the Seaside namespace was originally done in the Seaside bundle (see below). However it had to be defined earlier so that the Squeak versions of the Date, Time, TimeZone and Color classes could be made available to the Seaside namespace.</li>
	<li>Seaside/VW Support - This package includes extensions to the VisualWorks classes that are needed by Seaside. It also includes the SeasidePlatformSupport class that is expected by Seaside. This class includes many utilities on the class side that are used to create the Seaside ports. Method #portSource answers a constant that represents the original source of the Seaside Monticello package.</li>
</ul></p>
<p>The contents of the Seaside-WebToolKit bundle are :
<ul>
	<li>Seaside/Patches - This package includes patches to the Seaside code in the form of extensions and overrides. These patches are there to fix issues that are still not fixed in the Seaside Squeak source.</li>
	<li>WebToolkit/Patches - This package includes patches to the WebToolkit code in the form of extensions and overrides. These patches are there to fix issues that are still not fixed in the WebToolkit product.</li>
	<li>Seaside/WebToolkit - This package contains the actual integration between Seaside and WebToolkit, i.e. pieces of software that are specific to WebToolkit. The most important item is the SeasideServlet class. Of interest is the AAADocumentation class that provides guidelines on how to set things up and a few methods that are used to build the sample HTTP server and the sample web site.</li>
</ul></p>
<p>The contents of the Seaside-Swazoo bundle are :
<ul>
	<li>Seaside/GIF - This package includes some classes from VisualWave that are needed to support GIF images, since Swazoo does not have any support for GIF.</li>
	<li>Swazoo/Patches - This package includes patches to the Swazoo code in form of extensions and overrides. It adds explicit support for cookies that is missing in Swazoo.</li>
	<li>Seaside/Patches - This package is the same as the one included in the Seaside-WebToolKit. See above.</li>
	<li>Seaside/Swazoo - This package contains the actual integration between Swazoo and WebToolkit, i.e. pieces of software that are specific to Swazoo. The most important item is the SeasideResource class. Of interest is the AAADocumentation class that provides guidelines on how to set things up and a few methods that are use to build the sample Swazoo server.</li>
</ul></p>
'! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq26
	^self
		question: 'How do I make Seaside VisualWorks serve shorter URLs such as http://localhost:8008/counter?'
		category: self categoryHowTo
		title: 'Serving a shorter URL for VisualWorks'
		htmlResponse: [ :html |

html paragraph:
'If you would like to make the VisualWorks Seaside application server manage all the path-information on its own and to let it appear in the root like:'.

html paragraph: [
	html anchor
		url: 'http://localhost:8008/counter';
		with: 'http://localhost:8008/counter' ].
	
html paragraph:
'then you need to load the SeasideShortPath parcel that can be found in the contributed/other/Seaside/BonusPack directory starting with VisualWorks 7.3' ]! !

!WAFAQRepositoryData class methodsFor: 'faq deployment' stamp: 'pmm 3/30/2007 21:29'!
faq27
	^self
		question: 'How to deploy Seaside VisualWorks behing Apache?'
		category: self categoryDeployment
		title: 'Running behind Apache'
		htmlResponse: [:html |
			html paragraph:		
'You can run Seaside under VisualWorks behind Apache using either the the CGI gateway or the CGI Perl Interface.'.
			html paragraph:		
'There is however some potential difficulties to take into consideration. By default, Seaside is designed to use only one WADispatcher object and the WADispatcher object has a hard-coded base URI. Therefore, if you start your image, access Seaside through TinyHttpServer, then access Seaside through Apache, the access through Apache should fail because the WADispatcher object has been initialized with the TinyHttpServer URI and does not recognize the Apache URI.'.
			html paragraph:		
'For instance if the first Seaside visitor comes in through TinyHttpServer with a request for ''seaside/go/counter'', the WADispatcher base path will be ''seaside/go''. When another visitor comes in through Apache with a request for ''cgi-bin/visualworks.pl/seaside/go/counter'', Seaside uses the REQUEST_URI environment variable and the WADispatcher does not find any match.'.
			html paragraph:		
'The problem would be solved if the Apache request would come with REQUEST_URI equals to ''seaside/go/counter''. This might be possible by modifying the perl script so that it modifies the REQUEST_URI variable before transfering the HTTP request to VisualWorks.'.
			html paragraph: [
				html text:		
'I (Michel Bany) recently made an attempt to solve this issue differently by implementing the concept of alternate servlet. See the Seaside '.
				html anchor url: 'http://lists.squeakfoundation.org/pipermail/seaside/2004-September/003627.html'; with: 'mailing list post'.
				html text: '.'].
			html paragraph:		
'With this concept there are two SeasideServlet instances rather than just one. Each instance has its own separate WADispatcher object. As a result you may serve Seaside applications through two different base URIs.'.
			html paragraph:		
'The alternate servlet support has been included in VW 7.3.'.
			html paragraph:		
'The parcel for alternate servlet support is inside the BonusPack folder and is named SeasideShortPath.
You will need to use a different URI when coming through Apache, something like for ''/cgi-bin/visualworks.pl/counter'' rather than for ''cgi-bin/visualworks.pl/seaside/go/counter''. With the later, Seaside would attempt to use the default servlet and would fail. With the former, it will drop into the alternate servlet and initialize a new WADispatcher with the right base path.
Having explained all this, I believe that the best solution will be to have multiple WADispatcher objects available for the SeasideServlet providing support for multiple channels into Seaside.'.
			]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq28
	^self
		question: 'How do I reset the Seaside administrator password?'
		category: self categoryHowTo
		title: 'Viewing and resetting Seaside passwords'
		htmlResponse: [ :html |

html paragraph:
'To view'.
	
html preformattedCode:
'	(WADispatcher default entryPoints at: ''config'') preferenceAt: #login.
	(WADispatcher default entryPoints at: ''config'') preferenceAt: #password.'.

html paragraph:
'and to change:'.

html preformattedCode:
'	(WADispatcher default entryPoints at: ''config'')
			preferenceAt: #login put: ''new id''.
	(WADispatcher default entryPoints at: ''config'')
			preferenceAt: #password put: ''new password''.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq29
	^self
		question: 'How do I purge all existing sessions that might be open.?'
		category: self categoryHowTo
		title: 'Purging Seaside sessions'
		htmlResponse: [:html |
			html preformattedCode:
'WARegistry clearAllHandlers.
Smalltalk garbageCollect.' ]
! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq3
	^self
		question: 'Applications built with Seaside'
		category: self categoryGeneral 
		htmlResponse: [:html |
			html text: 'As mentionned in the '.
			html anchor
				url: 'http://lists.squeakfoundation.org/pipermail/seaside/2003-August/001929.html';
				with: 'mailing list' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq30
	^self
		question: 'How do I provide an anchor where the document is created after the link is clicked?'
		category: self categoryHowTo
		title: 'Create a document after the link is clicked'
		htmlResponse: [:html |
			html paragraph:
'With the code shown below the MIME document is created at render time, but
the data I want sent is dependent upon the fields on the form.'.
			html code: [html preformatted:			
'	html anchor
		document: anObject mimeType: mimeTypeString fileName: fileNameString;
		text: ''Export (csv)''.
'].
			html paragraph:
'Is there a convenient way to make the document be created after the
link is clicked?'.
			html paragraph:
'Yes, this is a common problem. One solution is to create an anchor and redirect:'.
			html code: [html preformatted:			
'	html anchor
		callback: [ self session returnResponse: 
		   (WAResponse 
			document: anObject 
			mimeType: mimeTypeString 
			fileName: fileNameString) ];
   		with: ''Export''.
'].
			]
! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 3/30/2007 21:26'!
faq31
	^self
		question: 'My page displays unexpected text'
		category: self categoryWhatWrong
		title: 'Using the right renderer'
		htmlResponse: [:html |
			html paragraph:
'When you see unexpected text in your rendered page (typically html tag names), you may have to verify that you are using the correct renderer class.'.
			html paragraph:
'When you are using the old rendering API, you must tell Seaside to use the corresponding renderer class WAHtmlRenderer.
Your component must implement #rendererClass like this'.
			html code: [html preformatted:
'	rendererClass
		^WAHtmlRenderer
'].
			html paragraph:
'This is especially important when you upgrade to Seaside 2.7 from an older version.
In older versions of Seaside the default renderer was WAHtmlRenderer.
Starting with Seaside 2.7, the default renderer is WARenderCanvas.
Starting with Seaside 2.8, the old WAHtmlRenderer is no longer available.'
			]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:46'!
faq32
	^self
		question: 'What is new in Seaside 2.7?'
		category: self categoryGeneral
		title: 'New features in Seaside 2.7'
		htmlResponse: [:html |
html paragraph: [
	html text: 'See the original '.
	html anchor
		url: 'http://lists.squeakfoundation.org/pipermail/seaside/2007-February/010876.html';
		with: ' maling list post '.
	html text: '.'].

html paragraph: [
	html unorderedList
		list: #(
			'canvas renderer is default, the old renderer is deprecated'
			'new, canvas like header api'
			'file library'
			'some tools have been cleaned up'
			'new image map api (see WAScreenshot)'
			'many new elements including ruby'
			'#fixCallbackTemps an ugly hack upon an ugly hack that saves memory'
			'WARequestHandler refactoring'
			'WAAnchorTag >> #text: has been deprecated'
			'removed WATagBrush >> #tooltip:'
			'a deprecation api to make all these deprecations possible'
			'ability to open a debugger on the rendering stack of an element'
			'pretty printer fixes and improvements (including comments)'
			'cookie fixes'
			'convenience methods in WARequest'
			'WAListener (comet support)'
			'more stuff that we forgot about' ) ] ]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq33
	^self
		question: 'How does the basic Seaside request model work?'
		category: self categoryGeneral
		title: 'Seaside Request model'
		htmlResponse: [:html |

html paragraph: 
'Normally, the transition from one page to another is split into two request-
response cycles. The first triggers the callbacks associated with the
link or form elements, and Seaside sends back a 302 response,
redirecting the browser to another url. The second request triggers
no callbacks and is a "pure" HTTP GET. Seaside sends back an html
representation of the page in its new state. That page can be
reloaded as much as you like with no side effects.'.

html paragraph: 'This is the default case for anchors and form in GET mode.
For anchors this can be changed to a single GET request that triggers the callbacks
and renders the response by sending #navigation to the anchor tag.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq errors' stamp: 'pmm 3/30/2007 21:46'!
faq34
	^self
		question: 'I have some kind of JavaScript error'
		category: self categoryErrors
		title: 'JavaScript errors'
		htmlResponse: [ :html |
			
html paragraph: [
	html text: 'Use '.
	html anchor
		url: 'http://www.getfirebug.com/';
		with: 'Firebug'.
	html text: ' to get more information.' ] ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 4/6/2007 13:01'!
faq35
	^self
		question: 'How do I secure a Seaside application for deployment?'
		category: self categoryHowTo
		title: 'Securing a Seaside application for deployment'
		htmlResponse: [:html |
			html paragraph: [
html unorderedList
	list: #(
		'remove all not needed applications'
		'put the remaining applications into deployment mode'
		'remove the config application or choose a good username and password (not the default!!)'
		'make sure you''re projected against SQL-injection') ] ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 4/6/2007 13:03'!
faq36
	^self
		question: 'How does Seaside protect me against XSS?'
		category: self categoryHowTo
		title: 'XSS protection'
		htmlResponse: [:html |
			html paragraph: 
'Per default all output is escaped for HTML unless especially reqested by using the #html: method.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 4/15/2007 21:55'!
faq37
	^self
		question: 'How do I change the title of a page?'
		category: self categoryHowTo
		title: 'Changing the title of a page'
		htmlResponse: [ :html |
			html paragraph: [
html text: 'In a visible component implement:'.
html preformattedCode: '
updateRoot: anHtmlRoot
    super updateRoot: anHtmlRoot.
    anHtmlRoot title: ''the new pageTitle''' ] ]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq4
	^self
		question: 'Where can I find Seaside tutorials?'
		category: self categoryGeneral 
		htmlResponse: [:html |
			html text: 'As comprehensive list of tutorials can be found on the '.
			html anchor
				url: 'http://seaside.st/Tutorial/';
				with: 'Seaside tutorials page' ]! !

!WAFAQRepositoryData class methodsFor: 'faq what wrong' stamp: 'pmm 4/22/2007 23:14'!
faq41
	^self
		question: 'Why can''t I start WAKom on port 80?'
		category: self categoryWhatWrong
		title: 'WAKom on port 80'
		htmlResponse: [:html |
			html paragraph:
'Ports below 1024 require root rights. Make sure you have no other service listening on TCP port 80.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq5
	^self
		question: 'Is Seaside free? What license does Seaside use?'
		category: self categoryGeneral
		title: 'Seaside License'
		htmlResponse: [:html |
			html paragraph:
'As of the Seaside 2.5 release (which was beta as of 2004 Jan 08), Seaside has been under the MIT license. This means that you can use it to build commercial apps, royalty free, with no restrictions. Note that, besides Squeak, this also applies to commercial Smalltalks such as VisualWorks and Dolphin Smalltalk.'.
			html paragraph: 
				[html text: 'See more details on the '.
				html anchor
					url: 'http://seaside.st/License/';
					with: 'Seaside license page'.
				html text: '.'] ]! !

!WAFAQRepositoryData class methodsFor: 'faq general' stamp: 'pmm 3/30/2007 21:25'!
faq6
	^self
		question: 'How do I get Seaside?'
		category: self categoryGeneral
		title: 'Seaside Installation'
		htmlResponse: [ :html |
			
html heading level4 with: 'Squeak'.

html paragraph: [
	html text: 'The '.
	html anchor
		url: 'http://www.seaside.st/Download/';
		with: 'Seaside Download Page'.
	html text: 'describes the installation procedure and links to prebuilt images.' ].

html heading level4 with: 'VisualWorks'.
html paragraph:
'Starting with version 7.2.1, Seaside is shipped on the VisualWorks distribution CD.'.

html paragraph:
'Seaside can be loaded in the VisualWorks image using the Parcel Manager, section "Application Server" where you should be able to see the SeasideForWebToolkit parcel. There is some installation documentation in the parcel comments.'.

html paragraph: [
html text: 'Seaside can also be loaded from the public Store repository where  either of the following bundles can be loaded:'.
html unorderedList
	list: #(
		'SeasideForWebToolkit, or'
		'SeasideForSwazoo') ].
	
html paragraph:
'Usually, loading from the repository may give you a more recent version 
of Seaside, also it gives the choice of loading older versions of Seaside.
Since the repository is used to build the Seaside ports, it is possible
to get an unstable version, therefore it is recommended to load Seaside
from your hard disk using the Parcel Manager, unless you want to experiment
with newer versions of Seaside or if you are using a version of VisualWorks
older than 7.2.1.'.

html paragraph:
'After the VisualWorks installation, Seaside is located in the goodies/contributed/Seaside directory. More items can be found in this directory using the File Browser or the Parcel Manager, like an HTML Seaside introductory tutorial and the original Squeak code.'.

html paragraph: [
html text: 'Since VisualWorks 7.3 Seaside comes with even more items that can be found in this directory:'.

html unorderedList
	list: #(
		'SeasideForSwazoo - A parcel for using Seaside with Swazoo rather than WebToolkit. Note: you may load both SeasideForWebToolkit and SeasideForSwazoo in the same image.'
'SqueakBase - A prerequisite parcel that provides some compatibility with Squeak and that includes all the known Squeak compatibility extensions that could be found in the repository.'
'SeasideAsync - An optional parcel that adds AJAX capabilities to Seaside.'
'BonusPack - A bunch of parcels with Seaside examples, Seaside goodies like Adrian Lienhard''s Mewa, Lukas Renggli''s Scriptaculous library, the Web designer tool for manipulating graphic files, CSS stylesheets and Javascripts, plus various optional utility parcels.') ].

html heading level4 with: 'Dolphin Smalltalk' ]! !

!WAFAQRepositoryData class methodsFor: 'faq what' stamp: 'pmm 3/30/2007 21:26'!
faq7
	^self
		question: 'What is the difference between WAComponent(component) and WATask(task)?'
		category: self categoryWhat
		title: 'Difference Between Component And Task'
		response:

'Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn''t render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.
'! !

!WAFAQRepositoryData class methodsFor: 'faq deployment' stamp: 'pmm 3/30/2007 21:29'!
faq8
	^self
		question: 'How to exclude applications from the Seaside main dispatcher?'
		category: self categoryDeployment
		title: 'Excluding applications for deployment'
		htmlResponse: [ :html |

html paragraph:
'Before deploying for production, it is not a bad idea to remove from the Seaside dispatcher all those applications that are not strictly needed. Otherwise, users may accidentally enter the "counter" or the "store" demo applications.'.

html paragraph:
'First of all, you will have to explicitely designate those Seaside applications that are deployed. This is achieved by re-implementing the #isDeployed class method in the root component of the deployed applications. By default, this class method answers false, only the dispatcher editor ("config") and the dispatcher navigator ("browse") answer true.'.

html paragraph:
'Then ,to remove applications from the Seaside dispatcher, evaluate the following:'.

html preformattedCode:
'WADispatcher default trimForDeployment.'.

html paragraph:
'This will remove all those applications that answer false to message #isDeployed.' ]! !

!WAFAQRepositoryData class methodsFor: 'faq how to' stamp: 'pmm 3/30/2007 21:29'!
faq9
	^self
		question: 'How do I remove the tool bar?'
		category: self categoryHowTo
		title: 'Removing the tool bar'
		htmlResponse: [:html |
			html paragraph:
'Set the value of "Deployment Mode" to false using the dispatcher editor ("config").'.
			html paragraph:
'This can be also done programatically in the #initialize method of the application''s root component.'.
			html code: [html preformatted:
'	initialize
		| app |
		app := self registerAsApplication: ''app-name''.
		app preferenceAt: #deploymentMode put: true.
'].
			]
	! !

!WAFAQRepositoryData class methodsFor: 'finding' stamp: 'pmm 3/30/2007 21:21'!
findAll
	^self class selectors
		select: [ :selector | selector beginsWith: 'faq']
		thenCollect: [ :selector |
			(self perform: selector)
				id: (selector copyFrom: (selector findFirst: [ :each | each isDigit]) to: selector size) asNumber;
				yourself ]
! !

!WAFAQRepositoryData class methodsFor: 'faq index' stamp: 'pmm 5/21/2007 06:12'!
index
	"Used to order the categories in the UI"
	^(OrderedCollection new)
		add: self categoryGeneral;
		add: self categoryWhat;
		add: self categoryHowTo;
		add: self categoryWhatWrong;
		add: self categoryDeployment;
		add: self categoryErrors;
		add: self categoryUnclassified;
		yourself! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:24'!
question: q category: c htmlResponse: r 
	^self question: q category: c title: nil htmlResponse: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:24'!
question: q category: c response: r 
	^self question: q category: c title: nil response: [ :h | h html: r ]! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:24'!
question: q category: c title: tit htmlResponse: aBlockOrString 
	| renderBlock |
	renderBlock := aBlockOrString isString
		ifTrue: [ [ :html | html html: aBlockOrString ] ]
		ifFalse: [ aBlockOrString ].
	^self question: q category: c type: self typeHtml title: tit response: renderBlock! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:23'!
question: q category: c title: tit response: r 
	^self question: q category: c type: self typeText title: tit response: [ :h | h html: r ]! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:23'!
question: q category: c type: typ response: r 
	^self question: q category: c type: typ title: nil response: r ! !

!WAFAQRepositoryData class methodsFor: 'factory' stamp: 'pmm 3/30/2007 21:22'!
question: q category: c type: typ title: tit response: r 
	^self factory question: q category: c type: typ title: tit response: r ! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 16:15'!
typeHtml
	"Text with embedded HTML"
	^#html! !

!WAFAQRepositoryData class methodsFor: 'constants' stamp: 'mb 8/18/2006 15:37'!
typeText
	"Normal text, no embedded HTML"
	^#text! !

!WAFAQRepositoryData methodsFor: 'as yet unclassified' stamp: 'pmm 4/22/2007 23:09'!
TODO
	"http://www.djangoproject.com/documentation/faq/
	http://docs.turbogears.org/FAQ
	
	http://docs.turbogears.org/1.0"! !

Object subclass: #WAFrequentlyAskedQuestion
	instanceVariableNames: 'id question category type title response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Model'!

!WAFrequentlyAskedQuestion class methodsFor: 'instance creation' stamp: 'pmm 3/30/2007 21:22'!
question: q category: c type: typ title: tit response: r
	^self new question: q category: c type: typ title: tit response: r ! !

!WAFrequentlyAskedQuestion methodsFor: 'comparing' stamp: 'mb 8/18/2006 16:20'!
<= another
	^self id <= another id! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
category
	^ category! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'pmm 3/30/2007 12:46'!
detailId
	^'#detail-', self id displayString! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 13:34'!
id
	^ id! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 13:35'!
id: anInteger
	id := anInteger! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'pmm 3/30/2007 13:18'!
index
	^self category indexOfQuestion: self! !

!WAFrequentlyAskedQuestion methodsFor: 'testing' stamp: 'mb 8/18/2006 13:58'!
isHtml
	^self type = self repository typeHtml! !

!WAFrequentlyAskedQuestion methodsFor: 'testing' stamp: 'mb 8/18/2006 13:58'!
isText
	^self type = self repository typeText! !

!WAFrequentlyAskedQuestion methodsFor: 'printing' stamp: 'mb 8/18/2006 13:46'!
printOn: aStream
	aStream
		nextPutAll: 'FAQ #';
		nextPutAll: self id printString! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
question
	^question! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'pmm 3/30/2007 21:22'!
question: q category: c type: typ title: tit response: r 
	question := q.
	category := c.
	type := typ.
	title := tit.
	response := r.! !

!WAFrequentlyAskedQuestion methodsFor: 'private' stamp: 'mb 8/18/2006 16:20'!
repository
	^WAFAQRepositoryData default! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
response
	^ response! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:27'!
title
	^ title ifNil: [question].! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'pmm 3/30/2007 12:46'!
tocId
	^'#toc-', self id displayString! !

!WAFrequentlyAskedQuestion methodsFor: 'accessing' stamp: 'mb 8/18/2006 16:28'!
type
	^ type! !

WAComponent subclass: #WAFAQ
	instanceVariableNames: 'currentCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Presentation'!

!WAFAQ class methodsFor: 'class initialization' stamp: 'lr 5/17/2007 23:46'!
canBeRoot
	^ true! !

!WAFAQ class methodsFor: 'documentation' stamp: 'pmm 3/30/2007 16:07'!
description
	^'Frequently Asked Questions'! !

!WAFAQ class methodsFor: 'class initialization' stamp: 'pmm 3/30/2007 16:07'!
initialize
	self registerAsApplication: 'faq'! !

!WAFAQ methodsFor: 'private' stamp: 'pmm 3/30/2007 16:32'!
categoriesDo: aOneArgumentBlock
	self repository contents do: [ :each |
		each questions isEmpty ifFalse: [
			aOneArgumentBlock value: each ] ]! !

!WAFAQ methodsFor: 'rendering-detail' stamp: 'pmm 3/30/2007 13:28'!
renderCategoriesDetailOn: html

	html orderedList: [
		self categoriesDo: [ :each |
			html listItem: [
				self renderCategoryDetail: each on: html ] ] ]! !

!WAFAQ methodsFor: 'rendering-toc' stamp: 'pmm 3/30/2007 13:27'!
renderCategoriesTocOn: html

	html orderedList: [
		self categoriesDo: [ :each |
			html listItem: [
				self renderCategoryToc: each on: html ] ] ]! !

!WAFAQ methodsFor: 'rendering-detail' stamp: 'pmm 3/30/2007 13:44'!
renderCategoryDetail: aCategory on: html
	html
		heading
		level2;
		with: [
			html anchor
				name: aCategory detailId allButFirst;
				url: aCategory tocId;
				with: aCategory title ].

	aCategory questions do: [ :faq |
			self renderFaqDetail: faq on: html ]! !

!WAFAQ methodsFor: 'rendering-toc' stamp: 'pmm 3/30/2007 13:45'!
renderCategoryToc: aCategory on: html

	html anchor
		name: aCategory tocId allButFirst;
		url: aCategory detailId;
		with: aCategory title.

	html orderedList: [
		aCategory questions do: [ :faq |
			html listItem: [
				self renderFaqToc: faq on: html ] ] ]! !

!WAFAQ methodsFor: 'rendering' stamp: 'pmm 3/30/2007 13:28'!
renderContentOn: html

	html heading: 'Frequently Asked Questions'.
	
	self renderCategoriesTocOn: html.
	
	self renderCategoriesDetailOn: html.
! !

!WAFAQ methodsFor: 'rendering-detail' stamp: 'pmm 5/27/2007 18:18'!
renderFaqDetail: aFaq on: html
	html
		heading
		level3;
		title: aFaq tocId;
		with: [
			html anchor
				name: aFaq detailId allButFirst;
				url: aFaq tocId;
				with: aFaq question ].
	
	aFaq response value: html
	! !

!WAFAQ methodsFor: 'rendering-toc' stamp: 'pmm 3/30/2007 13:44'!
renderFaqToc: aFaq on: html

	html anchor
		name: aFaq tocId allButFirst;
		url: aFaq detailId;
		with: aFaq question! !

!WAFAQ methodsFor: 'model' stamp: 'mb 8/18/2006 15:25'!
repository
	^WAFAQRepository default! !

!WAFAQ methodsFor: 'path' stamp: 'pmm 3/30/2007 12:53'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside FAQ'! !

!WAHtmlCanvas methodsFor: '*SeasideFAQ' stamp: 'pmm 3/30/2007 13:54'!
preformattedCode: aBlock
	self preformatted: [
		self code: aBlock ]! !

TestCase subclass: #WAFAQTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideFAQ-Tests'!

!WAFAQTests methodsFor: 'resources' stamp: 'mb 8/18/2006 15:26'!
repository
	^WAFAQRepository default! !

!WAFAQTests methodsFor: 'testing' stamp: 'pmm 3/31/2007 00:08'!
testRepositoryContents
	| faqs |
	faqs := self repository contents.
	self assert: (faqs isKindOf: OrderedCollection).
	faqs do: [:each |
		self assert: (each isKindOf: WAFAQCategory).
		self assert: (each title isString).
		self assert: (each questions isKindOf: SortedCollection).
		each questions do: [:faq |
			self assert: faq class == WAFrequentlyAskedQuestion.
			self shouldnt: [ faq isHtml. faq isText ] raise: Error.
			self assert: (faq isHtml isKindOf: Boolean).
			self assert: (faq isText isKindOf: Boolean).
			self assert: faq id isInteger.
			self assert: faq question isString.
			self assert: faq response isBlock.
			self assert: faq title isString.
			self assert: faq type isSymbol. ] ]! !

!WAFAQTests methodsFor: 'testing' stamp: 'pmm 3/31/2007 00:06'!
testUniqueIds
	| faqs ids id |
	ids := Set new.
	faqs := self repository contents.
	faqs do: [:each |
		each questions do: [:faq |
			id := faq id.
			self assert: id notNil.
			self assert: id isInteger.
			self deny: (ids includes: id).
			ids add: id ] ]! !
WAFAQ initialize!
